/*
 * 
 * Copyright 2004 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * The contents of this file are subject to the Sun Community Source
 * License v3.0/Jini Technology Specific Attachment v 1.0 (the
 * "License"). You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at
 * http://wwws.sun.com/software/jini/licensing/SCSL3_JiniTSA1.html.
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Reference Code is Jini Technology Core Platform code, v2.0. The
 * Developer of the Reference Code is Sun Microsystems, Inc.
 * 
 * Contributor(s): Sun Microsystems, Inc.
 * 
 * The contents of this file comply with the Jini Technology Core
 * Platform Compatibility Kit, v2.0A.
 * 
 * Tester(s): Sun Microsystems, Inc.
 * 
 * Test Platform(s):
 * Java 2 SDK, Standard Edition, Version 1.4.2_03 for Solaris(TM)SPARC/x86
 * Java 2 SDK, Standard Edition, Version 1.4.2_03 for Linux (Intel x86)
 * Java 2 SDK, Standard Edition, Version 1.4.2_03 for Windows (Intel Platform)
 * 
 */
package com.sun.jini.outrigger.logstore;

import com.sun.jini.outrigger.StorableResource;
import com.sun.jini.outrigger.StoredResource;
import net.jini.id.Uuid;

import java.io.IOException;
import java.util.Arrays;

/**
 * Wrapper for outrigger objects that are leased resources.
 * This class records renews so that the
 * stored resource can be updated while the target is serialized.
 * When the stored resource is deserialized the (potentially)
 * updated expiration is set in the resource before it is returned.
 */
class Resource extends BaseObject implements StoredResource {
    static final long serialVersionUID = -4248052947306243840L;

    private byte[]	cookie;
    private long	expiration;

    Resource(StorableResource resource) {
	super(resource);
	final Uuid uuid = resource.getCookie();
	cookie = ByteArrayWrapper.toByteArray(uuid);
	expiration = resource.getExpiration();
    }

    byte[] getCookie() {
	byte first = cookie[0];	// forces byte array into memory from DB
	return cookie;
    }

    ByteArrayWrapper getCookieAsWrapper() {
	return new ByteArrayWrapper(cookie);
    }

    void setExpiration(long newExpiration) {
	expiration = newExpiration;
    }

    public void restore(StorableResource obj)
	throws IOException, ClassNotFoundException 
    {
	super.restore(obj);

	// Set the objects expiration to be the current one (it may still
	// be the original expiration)
	//
	obj.setExpiration(expiration);
    }

    public int hashCode() {
        return ByteArrayWrapper.hashFor(cookie);
    }
 
    public boolean equals(Object o) {
        if (o == null)
            return false;
 
        if (!(o instanceof Resource))
            return false;
 
        // Same object if same cookie.
	return Arrays.equals(cookie, ((Resource)o).cookie);
    }
}
